from PIL import Image
import numpy as np


def matrix_colorize(A,exposure=1):
	# A = A.detach().cpu().numpy()
	A = A*exposure
	out = np.zeros(A.shape + (3,), dtype=np.uint8)
	# Color negative pixels as blue
	negative_indices = A < 0
	out[negative_indices, 2] = np.abs(A[negative_indices] * 255).astype(np.uint8)
	# Color positive pixels as red
	positive_indices = A > 0
	out[positive_indices, 0] = np.abs(A[positive_indices] * 255).astype(np.uint8)
	# 
	return out

def matrix_save_image(A, filepath):
	AA = matrix_colorize(A)
	image = Image.fromarray(AA, mode='RGB')  # Create RGB image from matrix
	image.save(filepath)

def matrix_rgb(A,rgb,exposure=1):
	# A = A.detach().cpu().numpy()
	A = A*exposure
	out = np.zeros(A.shape + (3,), dtype=np.uint8)
	out[:,:,0] = rgb[0]*(A*255).astype(np.uint8)
	out[:,:,1] = rgb[1]*(A*255).astype(np.uint8)
	out[:,:,2] = rgb[2]*(A*255).astype(np.uint8)
	return out

def matrix_rgb_save(A,rgb, filepath):
	Image.fromarray(matrix_rgb(A,rgb), mode='RGB').save(filepath)

